From fa2119c886a22c943fd05ef6e9ff07d20b0c0733 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 01:02:11 +0000
Subject: [PATCH 397/2232] Make some unsafe blocks smaller in vector generated code


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 8ec1107..3aeb831 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -664,22 +664,18 @@ fn expand_vector(namespace: &Namespace, ty: &Type) -> TokenStream {
                 __get_unchecked(v, pos)
             }
             fn __vector_size(v: &::cxx::CxxVector<#inner>) -> usize {
-                unsafe {
-                    extern "C" {
-                        #[link_name = #link_size]
-                        fn __vector_size(_: &::cxx::CxxVector<#inner>) -> usize;
-                    }
-                    __vector_size(v)
+                extern "C" {
+                    #[link_name = #link_size]
+                    fn __vector_size(_: &::cxx::CxxVector<#inner>) -> usize;
                 }
+                unsafe { __vector_size(v) }
             }
             fn __push_back(v: &::cxx::CxxVector<#inner>, item: &#inner) {
-                unsafe {
-                    extern "C" {
-                        #[link_name = #link_push_back]
-                        fn __push_back(_: &::cxx::CxxVector<#inner>, _: &#inner);
-                    }
-                    __push_back(v, item);
+                extern "C" {
+                    #[link_name = #link_push_back]
+                    fn __push_back(_: &::cxx::CxxVector<#inner>, _: &#inner);
                 }
+                unsafe { __push_back(v, item) }
             }
         }
     }
@@ -705,22 +701,18 @@ pub fn impl_vector_element_for_primitive(ident: Ident) -> TokenStream {
                 __get_unchecked(v, pos)
             }
             fn __vector_size(v: &CxxVector<#inner>) -> usize {
-                unsafe {
-                    extern "C" {
-                        #[link_name = #link_size]
-                        fn __vector_size(_: &CxxVector<#inner>) -> usize;
-                    }
-                    __vector_size(v)
+                extern "C" {
+                    #[link_name = #link_size]
+                    fn __vector_size(_: &CxxVector<#inner>) -> usize;
                 }
+                unsafe { __vector_size(v) }
             }
             fn __push_back(v: &CxxVector<#inner>, item: &#inner) {
-                unsafe {
-                    extern "C" {
-                        #[link_name = #link_push_back]
-                        fn __push_back(_: &CxxVector<#inner>, _: &#inner);
-                    }
-                    __push_back(v, item);
+                extern "C" {
+                    #[link_name = #link_push_back]
+                    fn __push_back(_: &CxxVector<#inner>, _: &#inner);
                 }
+                unsafe { __push_back(v, item) }
             }
         }
     }

